(* File absyn.ml *)
(* Stephanie Weirich, adapted from Amr Sabry *)

type var = string

type prim = Plus    (* + *)
          | Times   (* * *)
          | Minus   (* - *)
			 | Equal   (* = *)
			 | And     (* and *)
			 | Or      (* or  *)
			 | Not     (* not *)
			 | Zero    (* zero? *)
			 | LT      (* < *)
			 | GT      (* > *)
			 | Add1    (* add1 *)
			 | Sub1    (* sub1 *)

type exp = Var     of var             (* <var> *)
			| Lambda  of var list * exp  (* (lambda ({<var>}) <exp>) *)
			| App     of exp * exp list  (* (<exp> {<exp>}) *)
			| LitInt  of int             (* <number> *)
			| LitBool of bool            (* <boolean> *)
			| Prim    of prim * exp list (* (<prim> {<exp>}) *)
			| Let     of var list * exp list * exp 
                                      (* (let ({(<var> <exp>)}) <exp>) *)
			| If      of exp * exp * exp (* (if <exp> <exp> <exp>) *)
			| Letrec  of var list * var list list * exp list * exp
			
(********************************************************************)

