(* File main.ml *)
(* Stephanie Weirich, adapted from Amr Sabry *)

module P  = EoplParser
module L  = EoplLexer
module PP = EoplPrint
module E  = Eval

open Format

let _ = 
  try 
    flush stdout;
    let lexbuf = Lexing.from_channel stdin in

    while true do
      let f _ : unit = 
        try
          let e = P.main L.token lexbuf in
 				print_string "Input expression: ";
				print_newline();
				
			   PP.print_exp e;
				
				print_string "\nReduces to:\n";

				E.print_value (E.eval e E.Empty)

        with 
				Parsing.Parse_error ->
              (L.print_error "Parse error\n")
			 | E.TODO -> 
              (print_string "Not done\n")
			 | E.RuntimeError s -> 
				  (print_string s; print_newline ())
      in
      
		  f ();
		  print_string "\n******************\n";
        flush stdout
    done
  with L.Eof -> exit 0


